      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      INCLUDE 'APSCOM5.'

      real*8 q2lhbench(5)
      data q2lhbench /2d0, 4d0, 10d0, 24d0, 100d0/ 

      call initgridconst

c c-quark mass
      rmass(8)=sqrt(2d0)

c set-up for the strong coupling evolution
      kordalps=2
      q20alphas=rmass(8)**2
      alphas0=0.35d0

c filling the 4-flavour PDF grid  
      call fillvfngrid

c benchmark output of F_2,cc in different schemes 

      print *,'The c-quark semi-inclusive structure functions F_2^c', 
     -' (first column: momentum transferred in GeV^2,',
     -' second column: x, third column: 3-flavour FFNS value of F_2^c',
     -' 4-th column: asymptotic value of F_2^c in the 3-flavour scheme,',
     -' 5-th column: ZMVFNS value of F_2^c,',
     -' 6-th column: GMVFNS value of F_2^c in the BMSN prescription)'

      print *,'O(alpha_s^2) approximation'
      kordhq=1  !   O(\alpha_s^2)
      do n=1,5
        q2=q2lhbench(n)
        do nn=1,5
          xb=10.**(nn-6)
          a1=f2charm_ffn(xb,q2,8)
          a2=f2h_asymp(3,1,22,xb,q2,8)
          a3=f2h_vfn(3,1,22,xb,q2,8)
          a4=f2h_bmsn(3,1,22,xb,q2,8)
          write (*,fmt='(6e13.4)') q2,xb,a1,a2,a3,a4
        end do
      end do

      print *,'O(alpha_s^3) approximation'
      kordhq=2  !   O(\alpha_s^3)
      do n=1,5
        q2=q2lhbench(n)
        do nn=1,5
          xb=10.**(nn-6)
          a1=f2charm_ffn(xb,q2,8)
          write (*,fmt='(6e13.4)') q2,xb,a1
        end do
      end do

      stop
      end
